// VSTp̃CN[ht@C
#include "myvst3.h"

// ===================================================================================
// DLLt@C̏AI֐
// ===================================================================================
bool InitModule() { return true; }
bool DeinitModule() { return true; }

// ===================================================================================
// VSTvOC̐
// ===================================================================================
BEGIN_FACTORY_DEF(MYVST_VENDOR, MYVST_URL, MYVST_EMAIL)

	// MyVSTProcessorNX̐ݒs
	DEF_CLASS2(INLINE_UID_FROM_FUID(Steinberg::Vst::ProcessorUID),
	PClassInfo::kManyInstances,
	kVstAudioEffectClass,
	MYVST_VSTNAME,
	Vst::kDistributable,
	MYVST_SUBCATEGORIES,
	MYVST_VERSION,
	kVstVersionString,
	Steinberg::Vst::MyVSTProcessor::createInstance)

	// MyVSTControllerNX̐ݒs
	DEF_CLASS2(INLINE_UID_FROM_FUID(Steinberg::Vst::ControllerUID),
	PClassInfo::kManyInstances,
	kVstComponentControllerClass,
	MYVST_VSTNAME " Controller",// VST̖O"Controller"t^́B
	0,                          // gȂ̂ŕK0ɂ
	"",                         // gȂ̂ŕK""ɂ
	MYVST_VERSION,
	kVstVersionString,
	Steinberg::Vst::MyVSTController::createInstance)

END_FACTORY

// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {

// ===================================================================================
// MProcessorNX
// ===================================================================================
MyVSTProcessor::MyVSTProcessor()
{
	// Rg[[FUIDݒ肷(K{)
	setControllerClass(ControllerUID);
}

// NX֐
tresult PLUGIN_API MyVSTProcessor::initialize(FUnknown* context)
{
	// ܂pNX̏{(K{)
	tresult result = AudioEffect::initialize(context);
	if (result == kResultTrue)
	{
		// ͂Əo͂ݒ
		addAudioInput(STR16("AudioInput"), SpeakerArr::kStereo);
		addAudioOutput(STR16("AudioOutput"), SpeakerArr::kStereo);

		// Kv΂̌AŗL̏{B
	}

	// kResultTrueԂB
	return result;
}


tresult PLUGIN_API MyVSTProcessor::process(ProcessData& data)
{
	// ͂Əo͂`FbN
	if (data.numInputs != 1 || data.numOutputs != 1)
	{
		return kResultTrue;
	}
	
	if (data.inputs[0].numChannels != 2 || data.outputs[0].numChannels != 2)
	{
		return kResultTrue;
	}


	// ́Eo̓obt@̃|C^[킩₷ϐɊi[
	Sample32* inL = data.inputs[0].channelBuffers32[0];
	Sample32* inR = data.inputs[0].channelBuffers32[1];
	Sample32* outL = data.outputs[0].channelBuffers32[0];
	Sample32* outR = data.outputs[0].channelBuffers32[1];

	// numSamplesŎTvA
	for (int32 i = 0; i < data.numSamples; i++)
	{
		// ͐MɊ|킹邽߂̔g`thetavZ
		Sample32 a = 1.0f;
		switch (type)
		{
		case 0: // TCg̏ꍇ
			// sin֐̒lvZBʂ0`1̊ԂɂȂ悤ɂ
			a = ((float)sin(theta) * 0.5f) + 0.5f;
			break;
		case 1: // Opg̏ꍇ
			// sin֐̌ʂt֐(asin)ɓnƎOpgɂȂB
			a = ((float)asin(sin(theta)) * 0.5f) + 0.5f;
			break;
		case 2: // `g̏ꍇ
			// sin֐̌ʂ0ȏ̏ꍇ1.0Ƃ邱Ƃŋ`gɂȂB
			a = (sin(theta) >= 0.0) ? (1.0f) : (0.0f);
			break;
		case 3: // mRMg̏ꍇ
			// theta2΂Ŋ]肪U 0`2 ̋`gɂȂB
			a = fmod(theta, 2.0 * 3.14159265) / (2.0 * 3.14159265);
			break;
		}

		// depthƔg` a͐MɊ|킹lvZ
		Sample32 b = (1.0f - depth) + (a * depth);

		// ͐Mb|킹
		outL[i] = b * inL[i];
		outR[i] = b * inR[i];

		// pxthetaɊpxčXV
		theta += (2.0 * 3.14159265 * freq) / 44100.0;
	}

	// ȂkResultTrueԂ(炭KkResultTrueԂ)
	return kResultTrue;
}

// ===================================================================================
// VST̃p[^[𐧌䂷邽߂ControllerNX
// ===================================================================================

// NX֐(K{)
tresult PLUGIN_API MyVSTController::initialize(FUnknown* context)
{
	// ܂pNX̏{
	tresult result = EditController::initialize(context);
	if (result == kResultTrue)
	{
		// Kv΂̌AŗL̏{B
		// ͉Ȃ
	}

	// kResultTrueԂB
	return result;
}


} } // namespace SteinbergVst̏I
