#pragma once

// VST3 SDK̃wb_t@C
#include "pluginterfaces\base\funknown.h"
#include "public.sdk/source/vst/vstaudioeffect.h"
#include "public.sdk/source/vst/vsteditcontroller.h"
#include "public.sdk/source/main/pluginfactory.h"
#include "pluginterfaces/vst/ivstparameterchanges.h"
#include "pluginterfaces/base/ibstream.h"
#include "vstgui/plugin-bindings/vst3editor.h"

// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {

#define MYVST_VENDOR   "C++ de VST"               // ()̖OB
#define MYVST_URL      "http://vstcpp.wpblog.jp/" // ()WebTCgURLB
#define MYVST_EMAIL    "mailto:xxxx@example.com"  // ()̘A惁[AhXB
#define MYVST_VSTNAME  "MyVST Name"               // 삷VST̖OB
#define MYVST_VERSION  "0"                        // 삷VST̃o[WB
#define MYVST_SUBCATEGORIES Vst::PlugType::kFx    // 삷VST̃JeSB

// FUID̐ݒ
static const FUID ProcessorUID(0x1E5620F0, 0xB0C54434, 0x93A6D2E6, 0x793DF84E);
static const FUID ControllerUID(0xDC821BA2, 0x3DCA437F, 0x85046563, 0x196B2BFD);

enum ParameterTag
{
	TYPE,
	DEPTH,
	FREQ
};

// ===================================================================================
// MProcessorNX
// ===================================================================================
class MyVSTProcessor : public AudioEffect
{
public:
	MyVSTProcessor();

	// NX֐(K{)
	tresult PLUGIN_API initialize(FUnknown* context) SMTG_OVERRIDE;

	// M֐(K{)
	tresult PLUGIN_API process(ProcessData& data) SMTG_OVERRIDE;

	// NX̏Ԃ̕ۑƓǍ֐
	tresult PLUGIN_API getState(IBStream* state) SMTG_OVERRIDE;
	tresult PLUGIN_API setState(IBStream* state) SMTG_OVERRIDE;

	// VST ProcessorNX̃CX^X쐬邽߂̊֐(K{)
	static FUnknown* createInstance(void*) { return (IAudioProcessor*)new MyVSTProcessor(); }

protected:
	int32      type  = 0;   // g̃^CvA0cTCgA1cOpgA2c`gA3cmRMgƂ
	ParamValue depth = 0.8; // ĝ([)A0`1͈̔͂Ƃ
	ParamValue freq  = 2.0; // g̎

	ParamValue theta = 0.0; // gŎgpSIN֐̊px
};


// ===================================================================================
// VST̃p[^[𐧌䂷邽߂ControllerNX
// ===================================================================================
class MyVSTController : public EditController
{
public:
	// NX֐(K{)
	tresult PLUGIN_API initialize(FUnknown* context) SMTG_OVERRIDE;

	// NX̕ۑԂ𔽉f֐
	tresult PLUGIN_API getState(IBStream* state) SMTG_OVERRIDE;
	tresult PLUGIN_API setState(IBStream* state) SMTG_OVERRIDE;

	// NXɉNX̏Ԃǂݍފ֐
	tresult PLUGIN_API setComponentState(IBStream* state) SMTG_OVERRIDE;

	// VSTvOCŗL̑(GUI)쐬֐
	IPlugView* PLUGIN_API createView(const char* name) SMTG_OVERRIDE;

	// VST ControllerNX̃CX^X쐬邽߂̊֐(K{)
	static FUnknown* createInstance(void*) { return (IEditController*)new MyVSTController(); }
};


} } // namespace SteinbergVst̏I
