#pragma once

// VST3 SDK̃wb_t@C
#include "pluginterfaces\base\funknown.h"
#include "public.sdk/source/vst/vstaudioeffect.h"
#include "public.sdk/source/vst/vsteditcontroller.h"
#include "public.sdk/source/main/pluginfactory.h"
#include "pluginterfaces/vst/ivstparameterchanges.h"
#include "pluginterfaces/base/ibstream.h"
#include "pluginterfaces/vst/ivstevents.h"          // CxgoXpɕKv
#include "pluginterfaces/vst/ivstmidicontrollers.h" // MIDIPitchBendControlChange߂ɕKv

#include <vector>
using namespace std;

// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {

#define MYVST_VENDOR   "C++ de VST"               // ()̖OB
#define MYVST_URL      "http://vstcpp.wpblog.jp/" // ()WebTCgURLB
#define MYVST_EMAIL    "mailto:xxxx@example.com"  // ()̘A惁[AhXB
#define MYVST_VSTNAME  "MyVST Name2"              // 삷VST̖OB
#define MYVST_VERSION  "0"                        // 삷VST̃o[WB
#define MYVST_SUBCATEGORIES Vst::PlugType::kInstrument    // 삷VST̃JeSB

// FUID̐ݒ
static const FUID ProcessorUID(0x1E5620F0, 0xB0C54434, 0x93A6D2E6, 0x793DF841);
static const FUID ControllerUID(0xDC821BA2, 0x3DCA437F, 0x85046563, 0x196B2BF4);

enum ParameterTag
{
	PITCHBEND
};

// ===================================================================================
// MProcessorNX
// ===================================================================================
class MyVSTProcessor : public AudioEffect
{
public:
	MyVSTProcessor();

	// NX֐(K{)
	tresult PLUGIN_API initialize(FUnknown* context) SMTG_OVERRIDE;

	// M֐(K{)
	tresult PLUGIN_API process(ProcessData& data) SMTG_OVERRIDE;

	// VST ProcessorNX̃CX^X쐬邽߂̊֐(K{)
	static FUnknown* createInstance(void*) { return (IAudioProcessor*)new MyVSTProcessor(); }

protected:
	// MIDIm[gICxgAMIDIm[gItCxg󂯎ꍇɏ֐
	void onNoteOn(int channel, int note, float velocity);
	void onNoteOff(int channel, int note, float velocity);

	ParamValue pitchbend = 0.0; // sb`xh̒l

	double     pitch  = 0.0; //IV[^[̉(g)
	ParamValue volume = 0.0; // IV[^̉
	ParamValue theta  = 0.0; // IV[^ƂĎgpSIN֐̊px

	vector<int> noteList; // ꂽL[̉(g)ۑϒz
};


// ===================================================================================
// VST̃p[^[𐧌䂷邽߂ControllerNX
// ===================================================================================
class MyVSTController : public EditController, public IMidiMapping
{
public:
	// NX֐(K{)
	tresult PLUGIN_API initialize(FUnknown* context) SMTG_OVERRIDE;

	// VST ControllerNX̃CX^X쐬邽߂̊֐(K{)
	static FUnknown* createInstance(void*) { return (IEditController*)new MyVSTController(); }

	// MIDIPitchBendControlChangeƃp[^֘At֐
	tresult PLUGIN_API getMidiControllerAssignment(int32 busIndex, int16 channel, CtrlNumber midiControllerNumber, ParamID& id) SMTG_OVERRIDE;

	// VST{C^[tFCX(IMidiMapping )I[o[ChꍇɕKvȐ錾
	// DEF_INTERFACEɃC^[tFCXpĂB
	OBJ_METHODS(MyVSTController, EditController)
		DEFINE_INTERFACES
		DEF_INTERFACE(IMidiMapping)
		END_DEFINE_INTERFACES(EditController)
		REFCOUNT_METHODS(EditController)
};

} } // namespace SteinbergVst̏I
