// VSTp̃CN[ht@C
#include "myvst3.h"

// ===================================================================================
// DLLt@C̏AI֐
// ===================================================================================
bool InitModule() { return true; }
bool DeinitModule() { return true; }

// ===================================================================================
// VSTvOC̐
// ===================================================================================
BEGIN_FACTORY_DEF(MYVST_VENDOR, MYVST_URL, MYVST_EMAIL)

	// MyVSTProcessorNX̐ݒs
	DEF_CLASS2(INLINE_UID_FROM_FUID(Steinberg::Vst::ProcessorUID),
	PClassInfo::kManyInstances,
	kVstAudioEffectClass,
	MYVST_VSTNAME,
	Vst::kDistributable,
	MYVST_SUBCATEGORIES,
	MYVST_VERSION,
	kVstVersionString,
	Steinberg::Vst::MyVSTProcessor::createInstance)

	// MyVSTControllerNX̐ݒs
	DEF_CLASS2(INLINE_UID_FROM_FUID(Steinberg::Vst::ControllerUID),
	PClassInfo::kManyInstances,
	kVstComponentControllerClass,
	MYVST_VSTNAME " Controller",// VST̖O"Controller"t^́B
	0,                          // gȂ̂ŕK0ɂ
	"",                         // gȂ̂ŕK""ɂ
	MYVST_VERSION,
	kVstVersionString,
	Steinberg::Vst::MyVSTController::createInstance)

END_FACTORY

// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {

// ===================================================================================
// MProcessorNX
// ===================================================================================
MyVSTProcessor::MyVSTProcessor()
{
	// Rg[[FUIDݒ肷(K{)
	setControllerClass(ControllerUID);
}

// NX֐
tresult PLUGIN_API MyVSTProcessor::initialize(FUnknown* context)
{
	// ܂pNX̏{(K{)
	tresult result = AudioEffect::initialize(context);
	if (result == kResultTrue)
	{
		// ͂Əo͂ݒ
		addAudioInput(STR16("AudioInput"), SpeakerArr::kStereo);
		addAudioOutput(STR16("AudioOutput"), SpeakerArr::kStereo);

		// Kv΂̌AŗL̏{B
	}

	// kResultTrueԂB
	return result;
}


tresult PLUGIN_API MyVSTProcessor::process(ProcessData& data)
{
	// ͂Əo͂`FbN
	if (data.numInputs != 1 || data.numOutputs != 1)
	{
		return kResultTrue;
	}
	
	if (data.inputs[0].numChannels != 2 || data.outputs[0].numChannels != 2)
	{
		return kResultTrue;
	}


	// ́Eo̓obt@̃|C^[킩₷ϐɊi[
	Sample32* inL = data.inputs[0].channelBuffers32[0];
	Sample32* inR = data.inputs[0].channelBuffers32[1];
	Sample32* outL = data.outputs[0].channelBuffers32[0];
	Sample32* outR = data.outputs[0].channelBuffers32[1];

	// numSamplesŎTvA
	for (int32 i = 0; i < data.numSamples; i++)
	{
		// ͓͂̂܂܏o͂
		outL[i] = inL[i];
		outR[i] = inR[i];
	}

	// ȂkResultTrueԂ(炭KkResultTrueԂ)
	return kResultTrue;
}

// ===================================================================================
// VST̃p[^[𐧌䂷邽߂ControllerNX
// ===================================================================================

// NX֐(K{)
tresult PLUGIN_API MyVSTController::initialize(FUnknown* context)
{
	// ܂pNX̏{
	tresult result = EditController::initialize(context);
	if (result == kResultTrue)
	{
		// Kv΂̌AŗL̏{B
		// ͉Ȃ
	}

	// kResultTrueԂB
	return result;
}


} } // namespace SteinbergVst̏I
